=== modified file 'NEWS'
--- NEWS	2006-10-16 09:15:41 +0000
+++ NEWS	2006-10-17 07:53:51 +0000
@@ -47,7 +47,9 @@
       ``--no-plugins`` parameter to ensure test reproducability, and avoid
       problems with system-wide installed plugins. (John Arbash Meinel)
 
-    * Newly-initialized trees have unique root ids.  (Aaron Bentley)
+    * Unique tree root ids are now supported. Newly created trees still
+      use the common root id for compatibility with bzr versions before 0.12.
+      (Aaron Bentley)
 
     * ``WorkingTree.set_root_id(None)`` is now deprecated. Please
       pass in inventory.ROOT_ID if you want the default root id value.

=== modified file 'bzrlib/tests/test_workingtree.py'
--- bzrlib/tests/test_workingtree.py	2006-09-22 04:52:17 +0000
+++ bzrlib/tests/test_workingtree.py	2006-10-17 08:14:59 +0000
@@ -173,8 +173,14 @@
         t = control.get_workingtree_transport(None)
         self.assertEqualDiff('Bazaar-NG Working Tree format 3',
                              t.get('format').read())
-        self.assertContainsRe(t.get('inventory').read(), 
-                              '<inventory file_id="[^"]*" format="5">\n'
+        # self.assertContainsRe(t.get('inventory').read(), 
+        #                       '<inventory file_id="[^"]*" format="5">\n'
+        #                       '</inventory>\n',
+        #                      )
+        # WorkingTreeFormat3 doesn't default to creating a unique root id,
+        # because it is incompatible with older bzr versions
+        self.assertContainsRe(t.get('inventory').read(),
+                              '<inventory format="5">\n'
                               '</inventory>\n',
                              )
         self.assertEqualDiff('### bzr hashcache v5\n',

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2006-10-16 01:13:59 +0000
+++ bzrlib/workingtree.py	2006-10-17 07:49:07 +0000
@@ -2100,7 +2100,12 @@
         branch = a_bzrdir.open_branch()
         if revision_id is None:
             revision_id = branch.last_revision()
-        inv = Inventory(root_id=gen_root_id())
+        # WorkingTree3 can handle an inventory which has a unique root id.
+        # as of bzr 0.12. However, bzr 0.11 and earlier fail to handle
+        # those trees. And because there isn't a format bump inbetween, we
+        # are maintaining compatibility with older clients.
+        # inv = Inventory(root_id=gen_root_id())
+        inv = Inventory()
         wt = WorkingTree3(a_bzrdir.root_transport.local_abspath('.'),
                          branch,
                          inv,

